DirectInputInit           proto :HINSTANCE
CreateDirectInputDevice   proto :HWND
DestroyDirectInputDevices proto

;
; MACROS
;
CHECK_DDI MACRO
    .if (eax!=DI_OK)
        mov eax,FALSE
        ret
    .endif
endm

KeyDown macro KEY,RET_KEY,STATE
  LOCAL good,Ok  
  push esi
  mXOR eax
  mXOR esi
  mXOR edx
  mov esi,KEY
  mov dl,byte ptr keys[esi]
  test dl,80h
  jnz good
  mov eax,FALSE
  jmp Ok
good:
  mov eax,TRUE
Ok:   
  pop esi
  if STATE EQ TRUE
    Return_Key RET_KEY
  endif
  
endm

Return_Key macro Key
  .if (eax==TRUE)
      mov eax,Key
      ret
  .else
      mov eax,-1
      ret
  .endif
endm

;
; UN-INTIALIZED DATA
;
.data?
InputDevice LPDIRECTINPUT       ?   
m_keyboard  LPDIRECTINPUTDEVICE ? 
keys db 256 dup(?)